/*---------------------------------------------------------------------*/
/* --- STC MCU Limited ------------------------------------------------*/
/* --- STC 1T Series MCU Demo Programme -------------------------------*/
/* --- Mobile: (86)13922805190 ----------------------------------------*/
/* --- Fax: 86-0513-55012956,55012947,55012969 ------------------------*/
/* --- Tel: 86-0513-55012928,55012929,55012966 ------------------------*/
/* --- Web: www.STCMCU.com --------------------------------------------*/
/* --- Web: www.STCMCUDATA.com  ---------------------------------------*/
/* --- QQ:  800003751 -------------------------------------------------*/
/* Ҫڳʹô˴,ڳעʹSTCϼ        */
/*---------------------------------------------------------------------*/
//ߣ  QQ2334526772
//2022/8/30

#include "stc.h"
#include "USBSerial.h"
#include "usb.h"
#include "usb_req_class.h"


#define CDC_ENDPOINT_OUT	1
#define CDC_ENDPOINT_IN		1

#define CDC_RX_EP CDC_ENDPOINT_OUT
#define CDC_TX_EP CDC_ENDPOINT_IN

uint8_t xdata CDC_RX_Buffer[64];
volatile uint8_t xdata rx_length =0;
volatile uint8_t xdata rx_head = 0;
volatile sof_cnt = 0;


    
uint8_t USBSerial(){
    if (controlLineState)return 1;
    else return 0;
}


void USBSerial_flush(void){
    usb_write_reg(INDEX, CDC_TX_EP);
    usb_write_reg(OUTCSR1, OUTFLUSH);
    usb_write_reg(INCSR1, INFLUSH);
    rx_length = 0;
    rx_head = 0;
}

size_t USBSerial_write_bytes(uint8_t *p, size_t len)
{
    uint8_t i;
    uint8_t cnt;
    uint16_t addr;
    uint8_t *pdat;
//    EUSB = 0;
    if (DeviceState == DEVSTATE_CONFIGURED) 
    {
        usb_write_reg(INDEX, CDC_TX_EP);
        addr = 0;
        do
        {
            cnt = len > 64 ? 64 : len;
            while (usb_read_reg(INCSR1) & INIPRDY);
            pdat = p+addr;
            for(i=0;i<cnt;i++)
            {
                usb_write_reg(FIFO0 + CDC_TX_EP, *pdat++);
            }
//            usb_write_fifo((uint8_t)(FIFO0 + CDC_TX_EP), p+addr, cnt);
            
            usb_write_reg(INCSR1, INIPRDY);
            addr += cnt;
            len -= cnt;
        } while (cnt >= 64);
    

    }
//    EUSB = 1;
    return addr;
}

uint8_t USBSerial_write(char c)
{
    return USBSerial_write_bytes(&c, 1);
}

//ʵUSBSerial_printf
#include <stdarg.h>

int USBSerial_printf(const char *format, ...)
{
    char xdata buffer[64];
    va_list aptr;
    int ret;

    va_start(aptr, format);
    ret = vsprintf(buffer, format, aptr);
    USBSerial_write_bytes(buffer,ret);
    va_end(aptr);

    return(ret);
}

uint8_t USBSerial_available()
{
    return (rx_length - rx_head);
}


char USBSerial_read()
{
    char c;
    
    if(rx_length==0)return 0;
    c = CDC_RX_Buffer[rx_head++];
    sof_cnt = 0;
    if(rx_length==rx_head){
        usb_write_reg(INDEX, CDC_RX_EP);
        usb_write_reg(OUTCSR1, 0x00);
    }
    
    return c;
}

uint8_t USBSerial_read_bytes(uint8_t *p, uint8_t len)
{

    uint8_t cnt;

    cnt = len ;

    while (cnt--)
    {
        *p++ = CDC_RX_Buffer[rx_head++];
    }
    sof_cnt = 0;
    if(rx_length == rx_head){
        usb_write_reg(INDEX, CDC_RX_EP);
        usb_write_reg(OUTCSR1, 0x00);
    }
    
    return len;
}


//#include <string.h>
//#include "delay.h"
//char *USER_STCISPCMD = "@STCISP#";

void USBSerial_ep_out()
{
    rx_length = usb_read_fifo((uint8_t)(FIFO0 + CDC_RX_EP),CDC_RX_Buffer);
    rx_head = 0;

//    if(strncmp(USER_STCISPCMD,CDC_RX_Buffer,rx_length)==0)
//    {
//        usb_write_reg(INDEX, CDC_RX_EP);
//        usb_write_reg(OUTCSR1, 0x00);
//        EA = 0;
//        USBCON = 0x00;
//        P3M0 &= ~0x03;
//        P3M1 |= 0x03;
//        delay_ms(100);
//        IAP_CONTR = 0x60;
//        while(1);
//    }

}

//usb sofж϶ʱOUTCSR1㣬ֹUSBûжȡῨ
void USBSerial_sof_handler()
{
    uint8_t csr;
    if(++sof_cnt==1)
    {
        sof_cnt = 0;
        usb_write_reg(INDEX, CDC_RX_EP);
        csr = usb_read_reg(OUTCSR1);
        if (csr & OUTOPRDY)
        {
            usb_write_reg(OUTCSR1, 0);
        } 
    }     
}

